/*
 * Copyright (c) 2009, ConnectCode Pte Ltd
 *                     http://www.webextractor360.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of ConnectCode nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY ConnectCode Pte Ltd ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL ConnectCode Pte Ltd BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

using System.Text.RegularExpressions;
using WebExtractor360.look4me.Action;
using WebExtractor360.look4me.Util;
using WebExtractor360.look4me.Framework;
using WebExtractor360.look4me.Model;

using System.Windows.Forms;
using System.ComponentModel;

namespace WebExtractor360.look4me.Engine
{

    public class ExtractorProcessingEngine : WebProcessingEngine
    {
        public static string PARAM = "PARAM1";

        private ArrayList m_emailList;
        private string[] expressions;

        public ExtractorProcessingEngine(Uri startUri, int uriProcessedCountMax, string[] expressions, Framework.Action action, BackgroundWorker worker, DoWorkEventArgs workerevent)
           : base(startUri, uriProcessedCountMax, action, worker, workerevent)
        {
           m_emailList = new ArrayList();
           this.expressions = expressions;
        }

        override public void doHandleContents(Source source)
        {         
                int counter = 0;
                Match m = new Regex(expressions[0], RegexOptions.IgnoreCase).Match(source.Data);
                while (m.Success)
                {
                    Console.WriteLine("Results - " + m.Groups[PARAM].ToString());

                    ResultsValueObject rvo = new ResultsValueObject();
                    rvo.WebPage = source.Uri.AbsoluteUri.ToString();
                    rvo.Result = m.Groups[PARAM].ToString();
                    
                    m_emailList.Add(rvo);
                    counter++;
                    m = m.NextMatch();
                }
        }

        public IEnumerator GetResults()
        {
            return m_emailList.GetEnumerator();
        }

    }
}
