/*
 * Copyright (c) 2009, ConnectCode Pte Ltd
 *                     http://www.webextractor360.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of ConnectCode nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY ConnectCode Pte Ltd ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL ConnectCode Pte Ltd BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WebExtractor360.look4me.Action;
using WebExtractor360.look4me.Model;
using WebExtractor360.look4me.Framework;


namespace WebExtractor360
{
    namespace look4me
    {
        namespace Framework
        {

            public partial class TabForm : Form
            {
                public TabForm()
                {
                    InitializeComponent();                   
                }

                private TabControl baseTabCtrl;
                private TabPage baseTabPage;
                private Form mainForm;

                public Form BaseMainForm
                {
                    get
                    {
                        return mainForm;
                    }
                    set
                    {
                        mainForm = value;
                    }
                }

                public TabPage BaseTabPage
                {
                    get
                    {
                        return baseTabPage;
                    }
                    set
                    {
                        baseTabPage = value;
                    }
                }

                public TabControl BaseTabCtrl
                {
                    set
                    {
                        baseTabCtrl = value;
                    }
                    get
                    {
                        return baseTabCtrl;
                    }
                }

                private int saveResults;
                public int SaveResults
                {
                    set
                    {
                        saveResults = value;
                    }
                    get
                    {
                        return saveResults;
                    }
                }

                private int saveLinksProcessed;
                public int SaveLinksProcessed
                {
                    set
                    {
                        saveLinksProcessed = value;
                    }
                    get
                    {
                        return saveLinksProcessed;
                    }
                }

                private int saveSettings;
                public int SaveSettings
                {
                    set
                    {
                        saveSettings = value;
                    }
                    get
                    {
                        return saveSettings;
                    }
                }

                private System.Windows.Forms.TextBox textResults;
                public System.Windows.Forms.TextBox TextResults
                {
                    set
                    {
                        textResults = value;
                    }
                    get
                    {
                        return textResults;
                    }
                }

                private System.Windows.Forms.TextBox textProcess;
                public System.Windows.Forms.TextBox TextProcess
                {
                    set
                    {
                        textProcess = value;
                    }
                    get
                    {
                        return textProcess;
                    }
                }

                private ProfileValueObject profileValueObject;
                public ProfileValueObject ProfileValueObjectHolder
                {
                    set
                    {
                        profileValueObject = value;
                    }
                    get
                    {
                        return profileValueObject;
                    }
                }

                public void PopulateProfile()
                {
                    doPopulateProfile();
                }

                //Subclass will setup the individual items to be saved
                virtual public void doPopulateProfile()
                {
                }

                public void PopulateForm()
                {
                    doPopulateForm();
                }

                //Subclass will setup the individual items to be saved
                virtual public void doPopulateForm()
                {
                }

                private void button1_Click(object sender, EventArgs e)
                {
                    int currentIndex = BaseTabCtrl.SelectedIndex;
                    currentIndex--;

                    if (currentIndex > 0)
                        BaseTabCtrl.SelectedIndex = currentIndex;

                    BaseTabCtrl.TabPages.Remove(BaseTabPage);
 
                    Singleton.GetInstance().RemoveForm(this.Name);
                    this.Close();
                    this.Dispose();
                }

                public void CloseTabForm()
                {
                    object sender=null;
                    EventArgs e=null;
                    button1_Click(sender, e);
                }

        }
        }
    }
}