/*
 * Copyright (c) 2009, ConnectCode Pte Ltd
 *                     http://www.webextractor360.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of ConnectCode nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY ConnectCode Pte Ltd ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL ConnectCode Pte Ltd BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

using System;
using System.Collections.Generic;
using System.Text;

namespace WebExtractor360.look4me.Model
{
    [Serializable()]  
    public class ProfileValueObject : WebExtractor360.look4me.Framework.ValueObject
    {
        private string m_ProfileAction;

        public string ProfileAction
        {
            get { return m_ProfileAction; }
            set { m_ProfileAction = value; }
        }

        private string m_ProfileURL;

        public string ProfileURL
        {
            get { return m_ProfileURL; }
            set { m_ProfileURL = value; }
        }

        private string[] m_ProfileURLs;

        public string[] ProfileURLs
        {
            get { return m_ProfileURLs; }
            set { m_ProfileURLs = value; }
        }

        private int m_MaxURL;

        public int MaxURL
        {
            get { return m_MaxURL; }
            set { m_MaxURL = value; }
        }

        private int m_ExcludeLinksToItself;

        public int ExcludeLinksToItself
        {
            get { return m_ExcludeLinksToItself; }
            set { m_ExcludeLinksToItself = value; }
        }

        private int m_IncludeChecked;

        public int IncludeChecked
        {
            get { return m_IncludeChecked; }
            set { m_IncludeChecked = value; }
        }

        private string[] m_IncludeFilters;

        public string[] IncludeFilters
        {
            get { return m_IncludeFilters; }
            set { m_IncludeFilters = value; }
        }

        private int m_ExcludeChecked;

        public int ExcludeChecked
        {
            get { return m_ExcludeChecked; }
            set { m_ExcludeChecked = value; }
        }

        private string[] m_ExcludeFilters;

        public string[] ExcludeFilters
        {
            get { return m_ExcludeFilters; }
            set { m_ExcludeFilters = value; }
        }

        private string[] m_phrases;
        public string[] Phrases
        {
            get { return m_phrases;  }
            set { m_phrases = value; }
        }

        private int m_DownloadOption;

        public int DownloadOption
        {
            get { return m_DownloadOption; }
            set { m_DownloadOption = value; }
        }

        private string m_DownloadDirectory;
        public string DownloadDirectory
        {
            get { return m_DownloadDirectory; }
            set { m_DownloadDirectory = value; }
        }

        private string[] m_Expressions;
        public string[] Expressions
        {
            get { return m_Expressions; }
            set { m_Expressions = value; }
        }
    }
}
