/*
 * Copyright (c) 2009, ConnectCode Pte Ltd
 *                     http://www.webextractor360.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of ConnectCode nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY ConnectCode Pte Ltd ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL ConnectCode Pte Ltd BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

using System;
using System.Collections.Generic;
using System.Text;

namespace WebExtractor360.look4me.Model
{
    [Serializable()]  
    public class SearchOptionsValueObject : WebExtractor360.look4me.Framework.ValueObject
    {

        private bool m_emailStrongMatch;

        public bool EmailStrongMatch
        {
            get { return m_emailStrongMatch; }
            set { m_emailStrongMatch = value; }
        }

        private bool m_ignoreCriterion;

        public bool IgnoreCriterion
        {
            get { return m_ignoreCriterion; }
            set { m_ignoreCriterion = value; }
        }

        private bool m_reportLinksFound;

        public bool ReportLinksFound
        {
            get { return m_reportLinksFound; }
            set { m_reportLinksFound = value; }
        }

        private bool m_madCrawl;

        public bool MadCrawl
        {
            get { return m_madCrawl; }
            set { m_madCrawl = value; }
        }

        private bool m_includePageInResults;

        public bool IncludePageInResults
        {
            get { return m_includePageInResults; }
            set { m_includePageInResults = value; }
        }

    }
}
