/*
 * Copyright (c) 2009, ConnectCode Pte Ltd
 *                     http://www.webextractor360.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of ConnectCode nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY ConnectCode Pte Ltd ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL ConnectCode Pte Ltd BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;
using System.Threading;

namespace WebExtractor360.look4me.UserInterface
{
    
    public class ExtractorSplashScreen : Form
    {
        private static ExtractorSplashScreen m_trackscreen;
        private Bitmap m_bitmap;
        public static System.Timers.Timer Clock;

        public ExtractorSplashScreen(String imageFile, Color col)
        {
            m_bitmap = new Bitmap(imageFile);
            if (m_bitmap == null)
                throw new Exception("Bitmap file cannot be loaded " + imageFile);
            m_bitmap.MakeTransparent(col);

            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
            this.ShowInTaskbar = false;
            this.TopMost = true;
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.SplashForm_Paint);

            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Width = m_bitmap.Width;
            this.Height = m_bitmap.Height;
            m_trackscreen = this;
            
            Clock = new System.Timers.Timer();
            Clock.Interval = 4000;
            Clock.Start();
            Clock.Elapsed += new System.Timers.ElapsedEventHandler(CloseDown);
        }

        public static void CloseDown( object source, System.Timers.ElapsedEventArgs e )
        {
           Clock.Stop();
           m_trackscreen.InternalCloseSplash();
        }

        protected override void Dispose( bool disposing )
        {
            m_bitmap.Dispose();
            base.Dispose( disposing );
            m_trackscreen = null;
        }

        void InternalCloseSplash()
        {
            this.Close();
            this.Dispose();
        }
        
        private void SplashForm_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            e.Graphics.DrawImage(m_bitmap, 0,0);
        }

    }
}
